package org.xquark.xquery.parser.primitivefunctions.fnfunctions;

import java.util.ArrayList;

import org.xquark.xquery.parser.ParserVisitor;
import org.xquark.xquery.parser.PrimitiveFunctionCall;
import org.xquark.xquery.parser.QName;
import org.xquark.xquery.parser.XQueryException;
import org.xquark.xquery.parser.XQueryModule;
import org.xquark.xquery.parser.util.Constants;
import org.xquark.xquery.typing.TypeException;

public class FunctionADJUST_DATETIME_TO_TIMEZONE extends PrimitiveFunctionCall {
    // #############################################################################
    // VISITOR STUFF
    // #############################################################################

    public void accept(ParserVisitor visitor) throws XQueryException {
        visitor.visit(this);
    }

    // #############################################################################
    // CONSTRUCTOR STUFF
    // #############################################################################

    public FunctionADJUST_DATETIME_TO_TIMEZONE(ArrayList args, XQueryModule parentModule) throws TypeException, XQueryException {
        super(parentModule, new QName(Constants.FNURI, Constants.FN, "adjust-dateTime-to-timezone", null, null), args);
        if (parentModule != null && parentModule.getStaticContext().getTypeVisitor() != null)
            accept(parentModule.getStaticContext().getTypeVisitor());
    }

    // this function should be called with one argument
    public void setArguments(ArrayList arguments) throws XQueryException {
        if (arguments == null || arguments.size() < 1 || arguments.size() > 2)
            throw new XQueryException("Function adjust-dateTime-to-timezone should have one or two arguments");
        super.setArguments(arguments);
    }

}
