package org.xquark.xquery.parser.primitivefunctions.fnfunctions;

import java.util.ArrayList;

import org.xquark.xquery.parser.ParserVisitor;
import org.xquark.xquery.parser.PrimitiveFunctionCall;
import org.xquark.xquery.parser.QName;
import org.xquark.xquery.parser.XQueryException;
import org.xquark.xquery.parser.XQueryModule;
import org.xquark.xquery.parser.util.Constants;
import org.xquark.xquery.typing.TypeException;

public class FunctionIMPLICIT_TIMEZONE extends PrimitiveFunctionCall {
    // #############################################################################
    // VISITOR STUFF
    // #############################################################################

    public void accept(ParserVisitor visitor) throws XQueryException {
        visitor.visit(this);
    }

    // #############################################################################
    // CONSTRUCTOR STUFF
    // #############################################################################

    public FunctionIMPLICIT_TIMEZONE(ArrayList args, XQueryModule parentModule) throws TypeException, XQueryException {
        super(parentModule, new QName(Constants.FNURI, Constants.FN, "implicit-timezone", null, null), args);
        if (parentModule != null && parentModule.getStaticContext().getTypeVisitor() != null)
            accept(parentModule.getStaticContext().getTypeVisitor());
    }

    // this function should be called with one argument
    public void setArguments(ArrayList arguments) throws XQueryException {
        if (arguments != null && !arguments.isEmpty())
            throw new XQueryException("Function implicit-timezone should not have any argument");
        super.setArguments(arguments);
    }

}
