package org.xquark.xquery.parser.primitivefunctions.fnfunctions;

import java.util.ArrayList;

import org.xquark.xquery.parser.*;
import org.xquark.xquery.parser.util.Constants;
import org.xquark.xquery.typing.TypeException;

public class FunctionTIMEZONE_FROM_TIME extends PrimitiveFunctionCall {
    // #############################################################################
    // VISITOR STUFF
    // #############################################################################

    public void accept(ParserVisitor visitor) throws XQueryException {
        visitor.visit(this);
    }

    // #############################################################################
    // CONSTRUCTOR STUFF
    // #############################################################################

    public FunctionTIMEZONE_FROM_TIME(ArrayList args, XQueryModule parentModule) throws TypeException, XQueryException {
        super(parentModule, new QName(Constants.FNURI, Constants.FN, "timezone-from-time", null, null), args);
        if (parentModule != null && parentModule.getStaticContext().getTypeVisitor() != null)
            accept(parentModule.getStaticContext().getTypeVisitor());
    }

    // this function should be called with one argument
    public void setArguments(ArrayList arguments) throws XQueryException {
        if (arguments != null && arguments.size() > 1)
            throw new XQueryException("Function timezone-from-time should have at most one argument");
        super.setArguments(arguments);
    }

}
