package org.xquark.xquery.parser.primitivefunctions.xqjutilfunctions;

import java.util.ArrayList;

import org.xquark.xquery.parser.ParserVisitor;
import org.xquark.xquery.parser.PrimitiveFunctionCall;
import org.xquark.xquery.parser.QName;
import org.xquark.xquery.parser.XQueryException;
import org.xquark.xquery.parser.XQueryModule;
import org.xquark.xquery.parser.util.Constants;
import org.xquark.xquery.typing.TypeException;

public class FunctionALL_AVAILABLE_COLLECTION_URIS extends PrimitiveFunctionCall{
    
    // #############################################################################
    // VISITOR STUFF
    // #############################################################################
    
    public void accept(ParserVisitor visitor) throws XQueryException {
        visitor.visit(this);
    }
    
    // #############################################################################
    // CONSTRUCTOR STUFF
    // #############################################################################
    // xqj-util:all-available-collection-URIs() as xs:anyURI*
    // xqj-util:all-available-collection-URIs($parent as xs:anyURI) as xs:anyURI*

    // distinct-values(xqj-util:metadata()/xqjm:metadata/xqjm:collections//xqjm:collectionURI)
    // distinct-values(xqj-util:metadata()/xqjm:metadata/xqjm:collections//xqjm:collection[collectionURI = $parent]/childCollection//xqjm:collectionURI    
    public FunctionALL_AVAILABLE_COLLECTION_URIS(ArrayList args, XQueryModule parentModule) throws TypeException, XQueryException {
        super(parentModule, new QName(Constants.XQJ_UTILURI, Constants.XQJ_UTIL,"all-available-collection-URIs",null,null),args);
        //setQType(new QTypeDocument(new QTypeElement(new QName(null,"xqjm","metadata",parentModule,null),)))
        /*
        if (parentModule != null && parentModule.getStaticContext().getTypeVisitor() != null)
            accept(parentModule.getStaticContext().getTypeVisitor());
        */
    }

    public void setArguments(ArrayList arguments) throws XQueryException {
        if (arguments != null && arguments.size() != 1) throw new XQueryException("Function all-available-collection-URIs should have at most argument");
        super.setArguments(arguments);
    }

}
