package org.xquark.xquery.parser.primitivefunctions.xqjutilfunctions;

import java.util.ArrayList;

import org.xquark.xquery.parser.ParserVisitor;
import org.xquark.xquery.parser.PrimitiveFunctionCall;
import org.xquark.xquery.parser.QName;
import org.xquark.xquery.parser.XQueryException;
import org.xquark.xquery.parser.XQueryModule;
import org.xquark.xquery.parser.util.Constants;
import org.xquark.xquery.typing.TypeException;

public class FunctionAVAILABLE_DOCUMENT_URIS extends PrimitiveFunctionCall{
    
    // #############################################################################
    // VISITOR STUFF
    // #############################################################################
    
    public void accept(ParserVisitor visitor) throws XQueryException {
        visitor.visit(this);
    }
    
    // #############################################################################
    // CONSTRUCTOR STUFF
    // #############################################################################
    // xqj-util:available-document-URIs() as xs:anyURI*
    // xqj-util:available-document-URIs($parent as xs:anyURI) as xs:anyURI*

    // data(xqj-util:metadata()/xqjm:metadata/xqjm:documents/xqjm:document/xqjm:documentURI)
    // distinct-values(xqj-util:metadata()/xqj:metadata//xqjcollection[collectionURI = $parent]/childDocuments/document/xqjm:documentURI
    public FunctionAVAILABLE_DOCUMENT_URIS(ArrayList args, XQueryModule parentModule) throws TypeException, XQueryException {
        super(parentModule, new QName(Constants.XQJ_UTILURI, Constants.XQJ_UTIL,"available-document-URIs",null,null),args);
        //setQType(new QTypeDocument(new QTypeElement(new QName(null,"xqjm","metadata",parentModule,null),)))
        /*
        if (parentModule != null && parentModule.getStaticContext().getTypeVisitor() != null)
            accept(parentModule.getStaticContext().getTypeVisitor());
        */
    }

    public void setArguments(ArrayList arguments) throws XQueryException {
        if (arguments != null && arguments.size() != 1) throw new XQueryException("Function available-document-URIs should have at most argument");
        super.setArguments(arguments);
    }

}
