package org.xquark.xquery.parser.primitivefunctions.xqjutilfunctions;

import java.util.ArrayList;

import org.xquark.xquery.parser.InputFunctionCall;
import org.xquark.xquery.parser.ParserVisitor;
import org.xquark.xquery.parser.PrimitiveFunctionCall;
import org.xquark.xquery.parser.QName;
import org.xquark.xquery.parser.XQueryException;
import org.xquark.xquery.parser.XQueryModule;
import org.xquark.xquery.parser.util.Constants;
import org.xquark.xquery.typing.QTypeDocument;
import org.xquark.xquery.typing.QTypeElement;
import org.xquark.xquery.typing.TypeException;

public class FunctionMETADATA extends InputFunctionCall {

    // #############################################################################
    // VISITOR STUFF
    // #############################################################################
    
    public void accept(ParserVisitor visitor) throws XQueryException {
        visitor.visit(this);
    }
    
    // #############################################################################
    // CONSTRUCTOR STUFF
    // #############################################################################
    // xqj-util:metadata() as document(element(xqjm:metadata))
    public FunctionMETADATA(ArrayList args, XQueryModule parentModule) throws TypeException, XQueryException {
        super(parentModule, new QName(Constants.XQJ_UTILURI, Constants.XQJ_UTIL,"metadata",null,null),args);
        setQType(new QTypeDocument(new QTypeElement(new QName(null,"xqjm","metadata",parentModule,null),null),QTypeDocument.DOCUMENT_ORIGIN));
        /*
        if (parentModule != null && parentModule.getStaticContext().getTypeVisitor() != null)
            accept(parentModule.getStaticContext().getTypeVisitor());
        */
    }

    public void setArguments(ArrayList arguments) throws XQueryException {
        if (arguments != null) throw new XQueryException("Function metadata does not accept any argument");
        super.setArguments(arguments);
    }

}
